//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		wce_bugfix.h
 * @brief		Windows CE p WIN32API oOC t@C
 *
 * @author		t.sirayanagi
 * @version		1.0
 *
 * @par			copyright
 * Copyright (C) 2011 Takazumi Shirayanagi\n
 * The new BSD License is applied to this software.
 * see iris_LICENSE.txt
*/
//-----------------------------------------------------------------------
//======================================================================
#ifndef INCG_IRIS_wce_bugfix_H_
#define INCG_IRIS_wce_bugfix_H_

#if	defined(IRIS_WIN32_WCE)

//======================================================================
// include
#include "wce_inline.h"
#include "wce_wrap.h"

//======================================================================
// define
#ifdef CreateDialogParamA
#  undef CreateDialogParamA
#endif
#ifdef CreateDialogParamW
#  undef CreateDialogParamW
#endif

#define CreateDialogParamA(hInstance, lpszDlgName, hwndOwner, lpfnDialog, lParam)    \
    CreateDialogIndirectParamA(hInstance,   \
        (LPCDLGTEMPLATEA)LoadResource(hInstance, FindResourceA(hInstance, lpszDlgName, (LPSTR)RT_DIALOG)), \
        hwndOwner, lpfnDialog, lParam)
#define CreateDialogParamW(hInstance, lpszDlgName, hwndOwner, lpfnDialog, lParam)    \
    CreateDialogIndirectParamW(hInstance,   \
        (LPCDLGTEMPLATEW)LoadResource(hInstance, FindResourceW(hInstance, lpszDlgName, RT_DIALOG)), \
        hwndOwner, lpfnDialog, lParam)


#ifdef DialogBoxParamA
#  undef DialogBoxParamA
#endif
#ifdef DialogBoxParamW
#  undef DialogBoxParamW
#endif

#define DialogBoxParamA(hInstance, lpszDlgName, hwndOwner, lpfnDialog, lParam)    \
    DialogBoxIndirectParamA(hInstance,   \
        (LPCDLGTEMPLATEA)LoadResource(hInstance, FindResourceA(hInstance, lpszDlgName, (LPSTR)RT_DIALOG)), \
        hwndOwner, lpfnDialog, lParam)
#define DialogBoxParamW(hInstance, lpszDlgName, hwndOwner, lpfnDialog, lParam)    \
    DialogBoxIndirectParamW(hInstance,   \
        (LPCDLGTEMPLATEW)LoadResource(hInstance, FindResourceW(hInstance, lpszDlgName, RT_DIALOG)), \
        hwndOwner, lpfnDialog, lParam)



#endif

#endif
