//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		WceWrapGdi.h
 * @brief		GDI֌Wbv֐Q t@C
 *
 * @author		t.sirayanagi
 * @version		1.0
 *
 * @par			copyright
 * Copyright (C) 2010-2011 Takazumi Shirayanagi\n
 * The new BSD License is applied to this software.
 * see iris_LICENSE.txt
*/
//-----------------------------------------------------------------------
//======================================================================
#define INCG_IRIS_WceWrapGdi_CPP_

//======================================================================
// include
#include "WceWrapGdi.h"

#if	defined(IRIS_WIN32_WCE)

//======================================================================
// function
/**********************************************************************//**
 * @internal
 *
 * CreateFontA, W
 *
 -----------------------------------------------------------------------
 * @param [in]	nHeight			= 
 * @param [in]	nWidth			= 
 * @param [in]	nEscapement		= 
 * @param [in]	nOrientation	= 
 * @param [in]	nWeight			= 
 * @param [in]	bItalic			= 
 * @param [in]	bUnderline		= 
 * @param [in]	bStrikeOut		= 
 * @param [in]	iCharSet		= 
 * @param [in]	iOutPrecision	= 
 * @param [in]	iClipPrecision	= 
 * @param [in]	iQuality		= 
 * @param [in]	iPitchAndFamily	= 
 * @param [in]	pszFaceName		= 
*//***********************************************************************/
WINGDIAPI HFONT	WINAPI CreateFontA(int nHeight, int nWidth, int nEscapement, int nOrientation, int nWeight, DWORD bItalic
								   , DWORD bUnderline, DWORD bStrikeOut, DWORD iCharSet, DWORD iOutPrecision, DWORD iClipPrecision
								   , DWORD iQuality, DWORD iPitchAndFamily, LPCSTR pszFaceName)
{
#if 1
	return nullptr;
#else
	LOGFONTA lf;
	lf.lfCharSet		= (BYTE)iCharSet;
	lf.lfClipPrecision	= (BYTE)iClipPrecision;
	lf.lfEscapement		= nEscapement;
	lf.lfHeight			= nHeight;
	lf.lfItalic			= (BYTE)bItalic;
	lf.lfOrientation	= nOrientation;
	lf.lfOutPrecision	= (BYTE)iOutPrecision;
	lf.lfPitchAndFamily	= (BYTE)iPitchAndFamily;
	lf.lfQuality		= (BYTE)iQuality;
	lf.lfStrikeOut		= (BYTE)bStrikeOut;
	lf.lfUnderline		= (BYTE)bUnderline;
	lf.lfWeight			= nWeight;
	lf.lfWidth			= nWidth;
	strcpy_s(lf.lfFaceName, sizeof(lf.lfFaceName), pszFaceName);
	return CreateFontIndirectA(&lf);
#endif
}
WINGDIAPI HFONT	WINAPI CreateFontW(int nHeight, int nWidth, int nEscapement, int nOrientation, int nWeight, DWORD bItalic
									 , DWORD bUnderline, DWORD bStrikeOut, DWORD iCharSet, DWORD iOutPrecision, DWORD iClipPrecision
									 , DWORD iQuality, DWORD iPitchAndFamily, LPCWSTR pszFaceName)
{
	LOGFONTW lf;
	lf.lfCharSet		= (BYTE)iCharSet;
	lf.lfClipPrecision	= (BYTE)iClipPrecision;
	lf.lfEscapement		= nEscapement;
	lf.lfHeight			= nHeight;
	lf.lfItalic			= (BYTE)bItalic;
	lf.lfOrientation	= nOrientation;
	lf.lfOutPrecision	= (BYTE)iOutPrecision;
	lf.lfPitchAndFamily	= (BYTE)iPitchAndFamily;
	lf.lfQuality		= (BYTE)iQuality;
	lf.lfStrikeOut		= (BYTE)bStrikeOut;
	lf.lfUnderline		= (BYTE)bUnderline;
	lf.lfWeight			= nWeight;
	lf.lfWidth			= nWidth;
	wcscpy_s(lf.lfFaceName, sizeof(lf.lfFaceName), pszFaceName);
	return CreateFontIndirectW(&lf);
}

/**********************************************************************//**
 * @internal
 *
 * ExtCreatePen
 *
 -----------------------------------------------------------------------
 * @param [in]	iPenStyle	= 
 * @param [in]	cWidth		= 
 * @param [in]	plbrush		= 
 * @param [in]	cStyle		= 
 * @param [in]	pstyle		= 
 * @return	yIuWFNg
*//***********************************************************************/
WINGDIAPI HPEN	WINAPI	ExtCreatePen(DWORD iPenStyle, DWORD cWidth, CONST LOGBRUSH *plbrush, DWORD cStyle, CONST DWORD *pstyle)
{
	if( plbrush == nullptr ) return nullptr;
	return ::CreatePen(iPenStyle, cWidth, plbrush->lbColor);
}

#endif

