//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		DXCoordinates.h
 * @brief		DirectXWn̑It@C
 *
 * @author		t.sirayanagi
 * @version		1.0
 *
 * @par			copyright
 * Copyright (C) 2009-2011 Takazumi Shirayanagi\n
 * The new BSD License is applied to this software.
 * see iris_LICENSE.txt
*/
//-----------------------------------------------------------------------
//======================================================================
#ifndef INCG_IRIS_DXCoordinates_H_
#define INCG_IRIS_DXCoordinates_H_

#include "dx_inchead.h"

#ifndef _IRIS_DX_RIGHTHAND
// WniftHgj

#define D3DXMatrixLookAt				D3DXMatrixLookAtLH
#define D3DXMatrixPerspective			D3DXMatrixPerspectiveLH
#define D3DXMatrixPerspectiveFov		D3DXMatrixPerspectiveFovLH
#define D3DXMatrixPerspectiveOffCenter	D3DXMatrixPerspectiveOffCenterLH
#define D3DXMatrixOrtho					D3DXMatrixOrthoLH
#define D3DXMatrixOrthoOffCenter		D3DXMatrixOrthoOffCenterLH

#define DXCULL_FACE						D3DCULL_CCW
#define	DXCULL_BACK						D3DCULL_CW

#else
// EWn
#define D3DXMatrixLookAt				D3DXMatrixLookAtRH
#define D3DXMatrixPerspective			D3DXMatrixPerspectiveRH
#define D3DXMatrixPerspectiveFov		D3DXMatrixPerspectiveFovRH
#define D3DXMatrixPerspectiveOffCenter	D3DXMatrixPerspectiveOffCenterRH
#define D3DXMatrixOrtho					D3DXMatrixOrthoRH
#define D3DXMatrixOrthoOffCenter		D3DXMatrixOrthoOffCenterRH

#define DXCULL_FACE						D3DCULL_CW
#define	DXCULL_BACK						D3DCULL_CCW

#endif

#endif
