//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		DXFilter.h
 * @brief		directX tB^[NXt@C
 *
 * @author		t.sirayanagi
 * @version		1.0
 *
 * @par			copyright
 * Copyright (C) 2009-2011 Takazumi Shirayanagi\n
 * The new BSD License is applied to this software.
 * see iris_LICENSE.txt
*/
//-----------------------------------------------------------------------
//======================================================================
#ifndef INCG_IRIS_DXFilter_H_
#define INCG_IRIS_DXFilter_H_

//======================================================================
// include
#include "../texture/DXRenderTexture.h"

namespace iris {
namespace dx
{

//======================================================================
// class
//! tB^[NX
template<typename RENDERER>
class CDXFilter : virtual public RENDERER
{
public:
	/// RXgN^
	CDXFilter(void)		{}
	/// fXgN^
	//virtual ~CDXFilter(void)	{}
public:
	// rh
	virtual	void	Build(void)
	{
		RENDERER::Build();
		FitBackBufferSize();
	}
protected:
	/// XgA
	/// FitBackBufferSizeĂ
	virtual	void	Restore(void)
	{
		FitBackBufferSize();
	}
};

}	// end of namespace dx
}	// end of namespace iris

#endif
