//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		DXSprite.h
 * @brief		DXSprite t@C
 *
 * @author		t.sirayanagi
 * @version		1.0
 *
 * @par			copyright
 * Copyright (C) 2011 Takazumi Shirayanagi\n
 * The new BSD License is applied to this software.
 * see iris_LICENSE.txt
*/
//-----------------------------------------------------------------------
//======================================================================
#ifndef INCG_IRIS_DXSprite_H_
#define INCG_IRIS_DXSprite_H_

//======================================================================
// include
#include "../DXObject.h"

namespace iris {
namespace dx
{

#if	!defined(_IRIS_SUPPORT_DXMOBILE)

//======================================================================
// class
/**
 * @biref	XvCgNX
*/
class CDXSprite : virtual public IDXGXObject
{
public:
	typedef CDXDeviceObject<LPDXSPRITE>	SPRITE;

protected:
	SPRITE	m_pSprite;	//!< XvCg

public:
	// RXgN^
	CDXSprite(void);
	// fXgN^
	virtual ~CDXSprite(void);
public:
	//! 쐬
	virtual bool	Create(void);
	//! 
	virtual	void	Release(void);

protected:
	//! Zbg
	virtual	void	Reset(void);
	//! XgA
	virtual	void	Restore(void);

public:
	const SPRITE&	GetSprite(void) const	{ return m_pSprite; }

};

#endif

}	// end of namespace dx
}	// end of namespace iris


#endif
