//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		dmx_def_rs.h
 * @brief		Render State `T|[g}Nwb_
 *
 * @author		t.sirayanagi
 * @version		1.0
 *
 * @par			copyright
 * Copyright (C) 2010-2011 Takazumi Shirayanagi\n
 * The new BSD License is applied to this software.
 * see iris_LICENSE.txt
*/
//-----------------------------------------------------------------------
//======================================================================
#ifndef INCG_IRIS_dmx_def_rs_H_
#define INCG_IRIS_dmx_def_rs_H_

#if	defined(_IRIS_SUPPORT_DXMOBILE)

//======================================================================
// include
#include <d3dmx.h>

//======================================================================
// define
// D3DRENDERSTATETYPE
#define D3DRS_FILLMODE					D3DMRS_FILLMODE
#define D3DRS_SHADEMODE					D3DMRS_SHADEMODE
#define D3DRS_ZWRITEENABLE				D3DMRS_ZWRITEENABLE
#define D3DRS_ALPHATESTENABLE			D3DMRS_ALPHATESTENABLE
#define D3DRS_LASTPIXEL					D3DMRS_LASTPIXEL
#define D3DRS_SRCBLEND					D3DMRS_SRCBLEND
#define D3DRS_DESTBLEND					D3DMRS_DESTBLEND
#define D3DRS_CULLMODE					D3DMRS_CULLMODE
#define D3DRS_ZFUNC						D3DMRS_ZFUNC
#define D3DRS_ALPHAREF					D3DMRS_ALPHAREF
#define D3DRS_ALPHAFUNC					D3DMRS_ALPHAFUNC
#define D3DRS_DITHERENABLE				D3DMRS_DITHERENABLE
#define D3DRS_ALPHABLENDENABLE			D3DMRS_ALPHABLENDENABLE
#define D3DRS_FOGENABLE					D3DMRS_FOGENABLE
#define D3DRS_SPECULARENABLE			D3DMRS_SPECULARENABLE
#define D3DRS_FOGCOLOR					D3DMRS_FOGCOLOR
#define D3DRS_FOGTABLEMODE				D3DMRS_FOGTABLEMODE
#define D3DRS_FOGSTART					D3DMRS_FOGSTART
#define D3DRS_FOGEND					D3DMRS_FOGEND
#define D3DRS_FOGDENSITY				D3DMRS_FOGDENSITY
#define D3DRS_DEPTHBIAS					D3DMRS_DEPTHBIAS
#define D3DRS_RANGEFOGENABLE			D3DMRS_RANGEFOGENABLE
#define D3DRS_STENCILENABLE				D3DMRS_STENCILENABLE
#define D3DRS_STENCILFAIL				D3DMRS_STENCILFAIL
#define D3DRS_STENCILZFAIL				D3DMRS_STENCILZFAIL
#define D3DRS_STENCILPASS				D3DMRS_STENCILPASS
#define D3DRS_STENCILFUNC				D3DMRS_STENCILFUNC
#define D3DRS_STENCILREF				D3DMRS_STENCILREF
#define D3DRS_STENCILMASK				D3DMRS_STENCILMASK
#define D3DRS_STENCILWRITEMASK			D3DMRS_STENCILWRITEMASK
#define D3DRS_TEXTUREFACTOR				D3DMRS_TEXTUREFACTOR
#define D3DRS_TEXTUREPERSPECTIVE		D3DMRS_TEXTUREPERSPECTIVE
#define D3DRS_WRAP0						D3DMRS_WRAP0
#define D3DRS_WRAP1						D3DMRS_WRAP1
#define D3DRS_WRAP2						D3DMRS_WRAP2
#define D3DRS_WRAP3						D3DMRS_WRAP3
#define D3DRS_CLIPPING					D3DMRS_CLIPPING
#define D3DRS_LIGHTING					D3DMRS_LIGHTING
#define D3DRS_AMBIENT					D3DMRS_AMBIENT
#define D3DRS_FOGVERTEXMODE				D3DMRS_FOGVERTEXMODE
#define D3DRS_COLORVERTEX				D3DMRS_COLORVERTEX
#define D3DRS_LOCALVIEWER				D3DMRS_LOCALVIEWER
#define D3DRS_NORMALIZENORMALS			D3DMRS_NORMALIZENORMALS
#define D3DRS_DIFFUSEMATERIALSOURCE		D3DMRS_DIFFUSEMATERIALSOURCE
#define D3DRS_SPECULARMATERIALSOURCE	D3DMRS_SPECULARMATERIALSOURCE
#define D3DRS_AMBIENTMATERIALSOURCE		D3DMRS_AMBIENTMATERIALSOURCE
#define D3DRS_COLORWRITEENABLE			D3DMRS_COLORWRITEENABLE
#define D3DRS_BLENDOP					D3DMRS_BLENDOP
#define D3DRS_ZENABLE					D3DMRS_ZENABLE
#define D3DRS_SLOPESCALEDEPTHBIAS		D3DMRS_SLOPESCALEDEPTHBIAS
#define D3D_MAXRENDERSTATES				D3DM_MAXRENDERSTATES

#define D3DRS_FORCE_ULONG				D3DMRS_FORCE_ULONG

// D3DZBUFFERTYPE
#define D3DZB_FALSE				D3DMZB_FALSE
#define D3DZB_TRUE				D3DMZB_TRUE
#define D3DZB_USEW				D3DMZB_USEW
#define D3DZB_FORCE_DWORD		D3DMZB_FORCE_DWORD

#endif

#endif
