//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		MfcPrivateProfile.h
 * @brief		MfcPrivateProfile t@C
 *
 * @author		t.sirayanagi
 * @version		1.0
 *
 * @par			copyright
 * Copyright (C) 2011 Takazumi Shirayanagi\n
 * The new BSD License is applied to this software.
 * see iris_LICENSE.txt
*/
//-----------------------------------------------------------------------
//======================================================================
#ifndef INCG_IRIS_MfcPrivateProfile_H_
#define INCG_IRIS_MfcPrivateProfile_H_

//======================================================================
// include
#include "iris_object.h"

namespace iris {
namespace mfc
{

//======================================================================
// class
/**
 * @brief	ini t@CNX
*/
class CPrivateProfile : public IIrisObject
{
protected:
	CString	m_Path;	//!< t@CpX

public:
	// RXgN^
	CPrivateProfile(void);
	CPrivateProfile(const CString& path);
public:
	// J
	void	Open(const CString& path);

public:
	// ZNV擾
	bool		GetSectionNames(CArray<CString>& names)	const;
	// ZNVɑ݂L[擾
	bool		GetSection(const CString& lpAppName, CArray<CString>& names)	const;
	// t@C當擾
	DWORD		GetString(const CString& lpAppName, const CString& lpKeyName, const CString& lpDefault, LPTSTR lpReturn, DWORD nSize)	const;
	// t@C琮l擾
	UINT		GetInt(const CString& lpAppName, const CString& lpKeyName, UINT nDefault)	const;


};

}	// end of namespace mfc
}	// end of namespace iris

#endif
