//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		WXDlgApplication.cpp
 * @brief		_CAOx[XAvP[Vt@C
 *
 * @author		t.sirayanagi
 * @version		1.0
 *
 * @par			copyright
 * Copyright (C) 2009-2011 Takazumi Shirayanagi\n
 * The new BSD License is applied to this software.
 * see iris_LICENSE.txt
*/
//-----------------------------------------------------------------------
//======================================================================
#define INCG_IRIS_WXDlgApplication_CPP_

//======================================================================
// include
#include "WXDlgApplication.h"

namespace iris {
namespace wx
{

/**********************************************************************//**
 *
 * RXgN^
 *
 ----------------------------------------------------------------------
 * @param [in]	AppName	= AvP[V
*//***********************************************************************/
CDlgApplication::CDlgApplication(LPCTSTR AppName)
: CApplication(AppName)
{
}

/**********************************************************************//**
 *
 * fXgN^
 *
*//***********************************************************************/
CDlgApplication::~CDlgApplication(void)
{
}

/**********************************************************************//**
 *
 * 
 *
 ----------------------------------------------------------------------
 * @return	
*//***********************************************************************/
bool CDlgApplication::Init()
{
	m_hInst = (HINSTANCE)GetModuleHandle(nullptr);
	// dNmF
	if(CheckMultiBoot()) return false;
	return OnInit();
}

/**********************************************************************//**
 *
 * 
 *
 ----------------------------------------------------------------------
 * @return 
*//***********************************************************************/
bool CDlgApplication::OnInit(void)
{
	if( m_hWnd != nullptr )
	{
		SetWindowText(m_AppName);
	}
	return CApplication::OnInit();
}

/**********************************************************************//**
 *
 * ANZ[^L[̊mF
 *
 ----------------------------------------------------------------------
 * @param [in]	msg	= sꂽbZ[W
 * @return	
*//***********************************************************************/
BOOL CDlgApplication::PreTranslateMessage(MSG* msg)
{
	int ret = CApplication::PreTranslateMessage(msg);
	if( ret == 0 )
		ret = CDlgBase::PreTranslateMessage(msg);
	return ret;
}

/**********************************************************************//*-
 *
 * Destroy
 *
*//***********************************************************************/
__IrisDlgEventFuncImpl(CDlgApplication, Destroy)
{
	IRIS_UNUSED_VARIABLE(hDlg);
	IRIS_UNUSED_VARIABLE(wParam);
	IRIS_UNUSED_VARIABLE(lParam);
	m_hWnd = nullptr;
	PostQuitMessage(0);
	return true;
}

}	// end of namespace wx
}	// end of namespace iris
